<!--
 Copyright (C) 2024 bAvenir

 This program and the accompanying materials are made
 available under the terms of the Eclipse Public License 2.0
 which is available at https://www.eclipse.org/legal/epl-2.0/

 SPDX-License-Identifier: EPL-2.0
-->

<div class="w-full h-full flex flex-col pb-4 overflow-y-auto">
  <div class="grow w-full">
    <p-treeTable
      [value]="contractsTree"
      [scrollable]="true"
      scrollHeight="calc(100svh - 168px)"
      [virtualScroll]="true"
      [virtualScrollItemSize]="170"
      [tableStyle]="{ 'min-height': '0px' }"
    >
      <ng-template pTemplate="body" let-rowNode let-rowData="rowData">
        <tr [ttRow]="rowNode">
          <td>
            <div
              class="flex items-center text-text-500"
              [ngClass]="{ 'px-6': isNode(rowData), 'px-12': isContract(rowData) }"
            >
              <p-treeTableToggler [rowNode]="rowNode" />
              <ng-container *ngIf="isOrg(rowData)">
                <app-org-preview [org]="rowData"></app-org-preview>
              </ng-container>
              <ng-container *ngIf="isNode(rowData)">
                <app-node-preview [node]="rowData"></app-node-preview>
              </ng-container>
              <ng-container *ngIf="isContract(rowData)">
                <app-contract-preview [contract]="rowData"></app-contract-preview>
              </ng-container>
            </div>
          </td>
          <td>
            <ng-container *ngLet="rowNode.node.status$ | async as status">
              <app-status [status]="$any(status) ?? defaultStatus"></app-status>
            </ng-container>
          </td>
        </tr>
      </ng-template>
    </p-treeTable>
  </div>
  <ng-container *ngLet="loading$ | async as loading">
    <div class="flex items-center justify-between gap-8">
      <p-button
        label="Back"
        icon="pi pi-chevron-left"
        [outlined]="true"
        severity="secondary"
        (click)="goBack()"
        [disabled]="loading || sendingDone"
      ></p-button>
      <p-button
        [label]="hasFailed ? 'Resend Failed' : 'Send Contracts'"
        [style]="{ width: '200px' }"
        [icon]="hasFailed ? 'pi pi-sync' : 'pi pi-envelope'"
        (onClick)="hasFailed ? resendFailedContracts() : sendContracts()"
        [loading]="loading"
        [disabled]="sendingDone && !hasFailed"
      ></p-button>
      <p-button
        label="Finish"
        [style]="{ width: '200px' }"
        [outlined]="true"
        [disabled]="loading || !sendingDone"
        severity="secondary"
        (onClick)="onFinish()"
      ></p-button>
    </div>
  </ng-container>
</div>
